Subject: bug#59820: [PATCH] * nadvice/nadvice.el: support non-symbol (closure/lambda) advices (old Emacs)

From: Daan Ro <[email-masked]>
Date: Tue, 13 Dec 2022 22:02:51 +0700

Use `warn` instead of `message`.

On Tue, Dec 13, 2022 at 9:59 PM daanturo <[email-masked]> wrote:

> > I usually recommend to use named
> > functions for advice anyway
>
> How about we still allow but warn against such problematic usage?
>
>
> On 13/12/2022 20:50, Stefan Monnier wrote:
> >> This patch provides the ELPA version (for Emacs < 24.4) of nadvice.el's
> >> advice-add the ability to handle anonymous advices.
> > [...]
> >> +(defun advice--ensure-symbol (func)
> >> +  (if (symbolp func)
> >> +      func
> >> +    (let* ((sym (intern (format "%S" func))))
> >> +      (unless (fboundp sym)
> >> +        (defalias sym func))
> >> +      sym)))
> > I'm not a big fan of this approach, and I usually recommend to use named
> > functions for advice anyway (avoids all kinds of problems like the
> > `advice-remove` failing to remove, or the equality test taking too much
> > time, ...).
> >
> > IOW I'd rather align the "real nadvice.el" with the one in GNU ELPA than
> > the other way around in this respect.
> >
> >
> >         Stefan
> >
> --
> Daanturo.
>

-- 
Daanturo.
From f30a1f6d815a038dde51ea09089e9aa2155c8c62 Mon Sep 17 00:00:00 2001
From: Daanturo <[email-masked]>
Date: Tue, 13 Dec 2022 21:28:03 +0700
Subject: [PATCH] * nadvice/nadvice.el: warn against non-symbol FUNCTIONs

---
 nadvice.el | 2 ++
 1 file changed, 2 insertions(+)

diff --git a/nadvice.el b/nadvice.el
index 443a5d0..c6666d0 100644
--- a/nadvice.el
+++ b/nadvice.el
@@ -57,6 +57,8 @@
   (if (symbolp func)
       func
     (let* ((sym (intern (format "%S" func))))
+      (warn "This version of nadvice.el recommends that \
+FUNCTION: %S is a named symbol instead." func)
       (unless (fboundp sym)
         (defalias sym func))
       sym)))
-- 
2.39.0